<template>
  <section
    class="pf-c-page__main-section pf-m-no-padding-mobile"
    id="session-list"
  >
    <div class="pf-c-card">
      <div class="pf-c-toolbar">
        <div class="pf-c-title pf-m-xl">
          Session list
        </div>
        <div class="pf-c-pagination" id="session-list-toolbar">
          <router-link
            id="createSession"
            class="pf-c-button pf-m-primary"
            type="button"
            to="/create"
          >
            <span class="pf-c-button__icon">
              <i class="fas fa-plus-circle" aria-hidden="true"></i>
            </span>
            Create Session
          </router-link>
        </div>
      </div>
      <table class="pf-c-table pf-m-grid-xl" role="grid" id="sessionList">
        <thead>
          <tr role="row">
            <th role="columnheader" scope="col" id="name">
              Name
            </th>
            <th role="columnheader" scope="col" id="date">
              Date
            </th>
            <th role="columnheader" scope="col" id="status">
              Status
            </th>
          </tr>
        </thead>
        <tbody role="rowgroup">
          <tr role="row" v-if="sessions.length == 0">
            <td role="cell" colspan="3">
              Sessions not found.
            </td>
          </tr>
          <tr
            role="row"
            v-for="session in sessions"
            :key="session.id"
            :id="session.id"
          >
            <th role="columnheader" data-label="Name">
              <div>
                <div>
                  {{ session.name }}
                </div>
                <router-link :to="`/details/${session.id}`">
                  Details
                </router-link>
              </div>
            </th>
            <td role="cell" data-label="Date">
              {{ dateFormat(session.date) }}
            </td>
            <td role="cell" data-label="Status">
              {{ session.status }}
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import Session from "../types/session";
import axios from "axios";
import moment from "moment";

@Component
export default class SessionList extends Vue {
  private apiUrl: string = process.env.VUE_APP_API_URL;
  private sessions: Session[] = [];
  private errorMessage = "";

  mounted() {
    this.getSessions();
  }

  getSessions(): void {
    axios
      .get<Session[]>(`${this.apiUrl}/api/session`)
      .then(response => {
        this.sessions = response.data.reverse();
      })
      .catch(() => {
        this.errorMessage = "Unexpected error trying to get sessions";
      });
  }

  dateFormat(date: string): string {
    return moment(date).format("DD/MM/YYYY");
  }
}
</script>
